.NOLIST			;signifie: ne rien mettre dans le listing
;PlayStatic.cpp translated for masm by ToutEnMasm
;/*
; * Copyright (c) 2006, Creative Labs Inc.
; * All rights reserved.
; * 
; * Redistribution and use in source and binary forms, with or without modification, are permitted provided
; * that the following conditions are met:
; * 
; *     * Redistributions of source code must retain the above copyright notice, this list of conditions and
; * 	     the following disclaimer.
; *     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
; * 	     and the following disclaimer in the documentation and/or other materials provided with the distribution.
; *     * Neither the name of Creative Labs Inc. nor the names of its contributors may be used to endorse or
; * 	     promote products derived from this software without specific prior written permission.
; * 
; * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
; * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
; * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
; * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
; * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
; * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
; * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; * POSSIBILITY OF SUCH DAMAGE.
; */


;------ emplacement des dclarations
	.686p
	.xmm
	.model flat, stdcall
	option casemap :none   ; case sensitive

	include translate.inc	;SDK translate include files (voir mon site)
	include windows.sdk
	include malloc.sdk
	TARGET_OS_MAC equ 0
	include al.sdk
	include alc.sdk
	include efx.sdk
	include efx-creative.sdk
	include xram.sdk
	include framework.sdk
	include cwaves.sdk
	;------- librairie courantes ,identiques masm32rt
	includelib libcmtd.lib 		
	includelib oldnames.lib
      includelib kernel32.lib
      includelib OpenAL32.lib
	includelib Ole32.lib
	;editmasm.ini pour l'environnement du projet
	;Failed to load ..\..\Media\Footsteps.wav
	include macro.inc
	.const
	extern c _FPinit:dword	; to load floating point library
	;avoid the R6002 floating point not loaded error 
	
	AlSourceCode PROTO
	;----------------------------------------------------------------
	NUMBUFFERS              equ 4
	SERVICE_UPDATE_PERIOD	equ 20	
	;------------------------------------------------------------------
	;-------- init C++ class ----------------------
	??2@YAPAXI@Z	PROTO SYSCALL :DWORD
	new TEXTEQU <??2@YAPAXI@Z>    
	??0CWaves@@QAE@XZ PROTO SYSCALL
	CWaves_CWaves TEXTEQU <??0CWaves@@QAE@XZ>
	ANSWER_CLASS STRUCT
		ulDataSize DWORD ?
		ulFrequency DWORD ?
		wfex WAVEFORMATEX	<>
		ulBytesWritten DWORD ?
		ulFormat DWORD ?
		WaveID DWORD ?
		ulBufferSize DWORD ?
		Mul_uiBuffers DWORD NUMBUFFERS dup (?)
	ANSWER_CLASS ENDS
	.data
	;reponse ANSWER_CLASS <>
	tampon db 100 dup (0)
	hInstance dd 0
	presource dd 0
	cause db "PlayMultiChannel Test Application translated by ToutEnMasm",13,10,0
	alfailed db "Failed to initialize OpenAL",13,10,0
	mediafailed db "Failed to load "
	;mediasource db "D:\Program Files\OpenAL 1.1 SDK\samples\media\Footsteps.wav",0
	mediasource db "E:\PlayMultiChannel\fiveptone.wav",0
	;mediasource db "faux.wav",0
	;------- format ----------------
	AL_FORMAT_QUAD16 DB "AL_FORMAT_QUAD16",0 ;: 4 Channel,   16 bit data
	AL_FORMAT_51CHN16 DB "AL_FORMAT_51CHN16",0 ;: 5.1 Channel, 16 bit data
	AL_FORMAT_61CHN16 DB "AL_FORMAT_61CHN16",0  ;	: 6.1 Channel, 16 bit data
	AL_FORMAT_71CHN16 DB "AL_FORMAT_71CHN16",0 	;: 7.1 Channel, 16 bit data		
	
	.code

	
;################################################################
PlayMultiChannel PROC uses esi edi ebx
	Local  uiSource:DWORD,iState
	Local  pmem_new,pWaveLoader,$T67973,__$EHRec$[3],tv84,$T67972
	Local  eBufferFormat:DWORD,iTotalBuffersProcessed,iBuffersProcessed
	LOCAL  pData:DWORD,iLoop,uiBuffer,iQueuedBuffers,answer
	;Local  wfex:WAVEFORMATEX ulDataSize ulFrequency Not allowed here
	Local  securite[200]:BYTE ;here to verify bad writing in it	
	Local  retour:DWORD
	ZEROLOCALES retour
	
	; Initialize Framework
	invoke ALFWInit	
	invoke ALFWprintf,addr cause ;"PlayMultiChannel Test Application translated by ToutEnMasm"
	invoke ALFWInitOpenAL
	.if eax == 0
		AutreLoupe:	
		invoke ALFWprintf,addr alfailed
		invoke ALFWShutdown
		mov retour,0
		jmp FindePlayMultiChannel
	.else
		;init the c++ class
		invoke new,1004H
		.if eax != 0
			mov pmem_new,eax
			mov ecx,eax
			invoke CWaves_CWaves
			mov pWaveLoader,eax		
		.endif
		;call init_class_asm
		.if pWaveLoader == 0 ;failed to initialyse
			invoke ALFWShutdownOpenAL			
			jmp AutreLoupe
		.endif
		invoke new,sizeof ANSWER_CLASS
		.if eax != 0
			mov answer,eax
			mov esi,eax
		.else
			call delet
			invoke ALFWShutdownOpenAL			
			jmp AutreLoupe			
		.endif		
				
	.endif
	;-------- all is ready ----------------
	;OpenAL implementations are only guaranteed to support MONO and STEREO Buffers, so we need
	;to check if this implementation supports multi-channel formats.
	;This is done by making alGetEnumValue calls to request the value of the Buffer Format Tag Enum (that will be
	;passed to an alBufferData call).   Enum Values are retrieved by string names.  The following names are defined
	;for multi-channel wave formats ...
	;"AL_FORMAT_QUAD16"	: 4 Channel,   16 bit data
	;"AL_FORMAT_51CHN16"	: 5.1 Channel, 16 bit data
	;"AL_FORMAT_61CHN16"	: 6.1 Channel, 16 bit data
	;"AL_FORMAT_71CHN16"	: 7.1 Channel, 16 bit data	
	;----------------------------------------------------------
	;For this example, we are going to play a 5.1 test file ...
	invoke alGetEnumValue,addr AL_FORMAT_51CHN16
	mov eBufferFormat,eax
	.if eBufferFormat == 0
		invoke ALFWprintf,SADR("No support for 5.1 playback!")
		echecFormat:
		call delet
		invoke ALFWShutdownOpenAL
		invoke ALFWShutdown
		return 0
	.endif
	;Generate an AL Buffer
	invoke alGenBuffers,NUMBUFFERS,addr [esi].ANSWER_CLASS.Mul_uiBuffers
	; Generate a Source to playback the Buffer
    	invoke alGenSources,1, addr uiSource 
	mov ecx,pWaveLoader
	call Verify_Securite
	invoke CWaves_OpenWaveFile,addr mediasource,addr [esi].ANSWER_CLASS.WaveID ;ok
	.if eax < 0
		invoke ALFWprintf,addr mediafailed
		jmp echecFormat
	.endif
	call Verify_Securite
	mov ecx,pWaveLoader
	invoke CWaves_GetWaveSize,[esi].ANSWER_CLASS.WaveID,addr [esi].ANSWER_CLASS.ulDataSize ;ok
	call Verify_Securite	
	mov ecx,pWaveLoader
	;----- problme ii -------------------------------------------
	invoke CWaves_GetWaveFrequency,[esi].ANSWER_CLASS.WaveID,addr [esi].ANSWER_CLASS.ulFrequency ;ok
	call Verify_Securite
	;NOTE : The WaveLoader class will use alGetEnumValue to find the appropriate format tag (if supported)
	mov ecx,pWaveLoader
	;invoke CWaves_GetWaveALBufferFormat,WaveID,addr alGetEnumValue,addr ulFormat ;ok
	mov edx,120bh ; ulFormat is verify c++
	mov [esi].ANSWER_CLASS.ulFormat,edx
	call Verify_Securite
	;Queue 250ms of audio data	
	mov ecx,pWaveLoader	
	invoke CWaves_GetWaveFormatExHeader,[esi].ANSWER_CLASS.WaveID,addr [esi].ANSWER_CLASS.wfex ;ok
	call Verify_Securite
	mov eax,[esi].ANSWER_CLASS.wfex.nAvgBytesPerSec
	shr eax,2
	mov	[esi].ANSWER_CLASS.ulBufferSize,eax
	;IMPORTANT : The Buffer Size must be an exact multiple of the BlockAlignment ...
	;ulBufferSize -= (ulBufferSize % wfex.nBlockAlign);		
	movzx ecx,word ptr [esi].ANSWER_CLASS.wfex.nBlockAlign
	mov	eax,[esi].ANSWER_CLASS.ulBufferSize
	xor	edx, edx
	div	ecx
	mov	eax,[esi].ANSWER_CLASS.ulBufferSize
	sub	eax, edx
	mov	[esi].ANSWER_CLASS.ulBufferSize, eax
	call Verify_Securite	
	.if [esi].ANSWER_CLASS.ulFormat == 0
		invoke ALFWprintf,SADR("Unknown Audio Buffer format")
	.else
		invoke new,[esi].ANSWER_CLASS.ulBufferSize
		mov pData,eax
		.if pData == 0
			invoke ALFWprintf,SADR("Out of memory")
		.else	
			;Set read position to start of audio data
			mov ecx,pWaveLoader				
			invoke CWaves_SetWaveDataOffset,[esi].ANSWER_CLASS.WaveID, 0
			call Verify_Securite
			;Clear AL Error
			invoke alGetError
			;Fill all the Buffers with audio data from the wavefile
			mov iLoop,0
			Buffer_loop:
				mov ecx,pWaveLoader				
				invoke CWaves_ReadWaveData,[esi].ANSWER_CLASS.WaveID, pData, [esi].ANSWER_CLASS.ulBufferSize,addr [esi].ANSWER_CLASS.ulBytesWritten
				call Verify_Securite
				.if sdword ptr eax > -1				
					mov ebx,iLoop
					invoke alBufferData,[esi].ANSWER_CLASS.Mul_uiBuffers[ebx*4],[esi].ANSWER_CLASS.ulFormat, pData, [esi].ANSWER_CLASS.ulBytesWritten, [esi].ANSWER_CLASS.ulFrequency
					invoke alSourceQueueBuffers,uiSource, 1,addr [esi].ANSWER_CLASS.Mul_uiBuffers[ebx*4]
					invoke alGetError
					.if eax != AL_NO_ERROR
							;When a multi-channel buffer is attached to a Source (either directly using AL_BUFFER) or
							;via Source Queuing ... the call will fail if the playback device does not have enough
							;resources to play the buffer.  (On H/W devices each channel of a Buffer requires a H/W voice,
							;so to play a 5.1 Buffer on a Source requires 6 H/W Voices).
							jmp error_al
					.endif
				.endif				
				inc iLoop
			.if iLoop < NUMBUFFERS
				jmp Buffer_loop
			.endif
			error_al:
			.if iLoop != NUMBUFFERS
				invoke ALFWprintf,SADR("Failed to attach MultiChannel buffer to Source")
			.else
				;Start playing source
				invoke alSourcePlay,uiSource
				mov iTotalBuffersProcessed, 0
				iskeypress:
				invoke ALFWKeyPress
				.if eax == 0
					invoke Sleep,SERVICE_UPDATE_PERIOD
					;Request the number of OpenAL Buffers have been processed (played) on the Source
					mov iBuffersProcessed,0
					invoke alGetSourcei,uiSource, AL_BUFFERS_PROCESSED,addr iBuffersProcessed					
					;Keep a running count of number of buffers processed (for logging purposes only)
					;iTotalBuffersProcessed += iBuffersProcessed;
					mov	eax,iTotalBuffersProcessed
					add	eax,iBuffersProcessed
					mov	iTotalBuffersProcessed, eax					
					invoke ALFWprintf,SADR("Buffers Processed %d"),iTotalBuffersProcessed
					call Verify_Securite
					;For each processed buffer, remove it from the Source Queue, read next chunk of audio
					;data from disk, fill buffer with new data, and add it to the Source Queue
					.while (iBuffersProcessed)
						;Remove the Buffer from the Queue.  (uiBuffer contains the Buffer ID for the unqueued Buffer)
						mov uiBuffer,0
						invoke alSourceUnqueueBuffers,uiSource, 1,uiBuffer
						;Read more audio data (if there is any)
						mov ecx,pWaveLoader				
						invoke CWaves_SetWaveDataOffset,[esi].ANSWER_CLASS.WaveID, 0	
						mov ecx,pWaveLoader					
						invoke CWaves_ReadWaveData,[esi].ANSWER_CLASS.WaveID, pData,[esi].ANSWER_CLASS.ulBufferSize,addr [esi].ANSWER_CLASS.ulBytesWritten
						.if [esi].ANSWER_CLASS.ulBytesWritten != 0
							;Copy audio data to Buffer
							invoke alBufferData,uiBuffer, [esi].ANSWER_CLASS.ulFormat, pData, [esi].ANSWER_CLASS.ulBytesWritten, [esi].ANSWER_CLASS.ulFrequency
							;Queue Buffer on the Source
							invoke alSourceQueueBuffers,uiSource, 1,uiBuffer
						.endif
						dec iBuffersProcessed
					.endw
					;Check the status of the Source.  If it is not playing, then playback was either completed,
					;or the Source was starved of audio data and needs to be restarted.
					invoke alGetSourcei,uiSource, AL_SOURCE_STATE,addr iState
					.if iState != AL_PLAYING
						;If there are Buffers in the Source Queue then the Source was starved of audio
						;data, so needs to be restarted (because there is more audio data to play)
						invoke alGetSourcei,uiSource, AL_BUFFERS_QUEUED,addr iQueuedBuffers
						.if iQueuedBuffers > 0
							invoke alSourcePlay,uiSource
						.else
							;Finished playing
							jmp Finished_play
						.endif
					.endif
					Finished_play:
					;Stop the Source and clear the Queue
					invoke alSourceStop,uiSource
					invoke alSourcei,uiSource,AL_BUFFER, 0
					;Release temporary storage
					invoke free,pData
					mov pData,NULL
					jmp cleanup					
				.endif
				jmp iskeypress
			.endif			
		.endif
	.endif
	cleanup:
    	;Clean up buffers and sources
	invoke alDeleteSources,1,addr uiSource
	invoke alDeleteBuffers,NUMBUFFERS,addr [esi].ANSWER_CLASS.Mul_uiBuffers
	.if pWaveLoader != 0
		call delet
	.endif
	call delet_answer
	invoke ALFWShutdownOpenAL
	invoke ALFWShutdown
 FindePlayMultiChannel:
         mov eax,retour
         ret
delet:
	;free the memory used by the class
	push	1
	mov	edx, pWaveLoader
	mov	eax, DWORD PTR [edx]
	mov	ecx, pWaveLoader
	mov	edx, DWORD PTR [eax]
	call	edx		;??_ECWavesUAEPAXIZ       windbg CWaves__`scalar deleting destructor
	;??_ECWaves@@UAEPAXI@Z (public: virtual void * __thiscall CWaves::`vector deleting destructor'(unsigned int))
      ;COMDAT; sym= "public: virtual void * __thiscall CWaves::`scalar deleting destructor'(unsigned int)" (??_GCWaves@@UAEPAXI@Z)	
retn
delet_answer:
	;free 
	invoke free, answer
retn
Verify_Securite:
	pushad
	lea esi,securite
	mov ecx,sizeof securite
	@@:
	.if byte ptr [esi] == 0
		dec ecx
		.if ecx != 0
			inc esi
			jmp @B
		.endif
	.else
		jmp cleanup
	.endif
	popad
retn

PlayMultiChannel endp

;################################################################

main PROC C argc:DWORD,pargv:DWORD
	invoke CoInitializeEx, NULL, COINIT_MULTITHREADED
	;pas de ExitProcess	;la fin est dans la librairie c ainsi que le dbut
	invoke PlayMultiChannel	
	invoke CoUninitialize		
	ret
main endp

end  
	
