.NOLIST			;signifie: ne rien mettre dans le listing
;PlayStatic.cpp translated for masm by ToutEnMasm
;/*
; * Copyright (c) 2006, Creative Labs Inc.
; * All rights reserved.
; * 
; * Redistribution and use in source and binary forms, with or without modification, are permitted provided
; * that the following conditions are met:
; * 
; *     * Redistributions of source code must retain the above copyright notice, this list of conditions and
; * 	     the following disclaimer.
; *     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
; * 	     and the following disclaimer in the documentation and/or other materials provided with the distribution.
; *     * Neither the name of Creative Labs Inc. nor the names of its contributors may be used to endorse or
; * 	     promote products derived from this software without specific prior written permission.
; * 
; * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
; * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
; * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
; * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
; * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
; * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
; * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; * POSSIBILITY OF SUCH DAMAGE.
; */


;------ emplacement des dclarations
	.686p
	.xmm
	.model flat, stdcall
	option casemap :none   ; case sensitive

	include translate.inc	;SDK translate include files (voir mon site)
	include windows.sdk
	include malloc.sdk
	include stdio.sdk
	TARGET_OS_MAC equ 0
	include al.sdk
	include alc.sdk
	include efx.sdk
	include efx-creative.sdk
	include xram.sdk
	include framework.sdk
	include cwaves.sdk
	include appel_cwave.inc
	;------- librairie courantes ,identiques masm32rt
	;includelib libcmtd.lib 		
	;includelib oldnames.lib
      includelib kernel32.lib
      includelib OpenAL32.lib
	includelib Ole32.lib
	includelib appel_cwave.lib
	;editmasm.ini pour l'environnement du projet
	;Failed to load ..\..\Media\Footsteps.wav
	include macro.inc
	.const
	;extern c _FPinit:dword	; to load floating point library
	;avoid the R6002 floating point not loaded error 
	
	AlSourceCode PROTO
	;----------------------------------------------------------------
	NUMBUFFERS              equ 4
	SERVICE_UPDATE_PERIOD	equ 20	
	;------------------------------------------------------------------
	;-------- init C++ class ----------------------
	.data
	;reponse ANSWER_CLASS <>
	tampon db 100 dup (0)
	hInstance dd 0
	presource dd 0
	cause db "PlayMultiChannel Test Application translated by ToutEnMasm",13,10,0
	alfailed db "Failed to initialize OpenAL",13,10,0
	mediafailed db "Failed to load "
	;mediasource db "D:\Program Files\OpenAL 1.1 SDK\samples\media\Footsteps.wav",0
	mediasource db "E:\PlayMultiChannel\fiveptone.wav",0
	;mediasource db "faux.wav",0
	;------- format ----------------
	AL_FORMAT_QUAD16 DB "AL_FORMAT_QUAD16",0 ;: 4 Channel,   16 bit data
	AL_FORMAT_51CHN16 DB "AL_FORMAT_51CHN16",0 ;: 5.1 Channel, 16 bit data
	AL_FORMAT_61CHN16 DB "AL_FORMAT_61CHN16",0  ;	: 6.1 Channel, 16 bit data
	AL_FORMAT_71CHN16 DB "AL_FORMAT_71CHN16",0 	;: 7.1 Channel, 16 bit data		
	 BufProceed db "Buffers Processed %d",13,0
	.code

	
;################################################################
PlayMultiChannel PROC uses esi edi ebx
	Local  uiSource:DWORD,iState,pmem_new
	local  ulDataSize:DWORD,ulFrequency,ulBytesWritten,ulFormat
	Local  WaveID:DWORD,ulBufferSize
	
	Local wfex:WAVEFORMATEX
	Local	Mul_uiBuffers[NUMBUFFERS]:DWORD 
	Local  eBufferFormat:DWORD,iTotalBuffersProcessed,iBuffersProcessed
	LOCAL  pData:DWORD,iLoop,uiBuffer,iQueuedBuffers,answer
	;Local  wfex:WAVEFORMATEX ulDataSize ulFrequency Not allowed here
	Local  securite[200]:BYTE ;here to verify bad writing in it	
	Local  retour:DWORD
	ZEROLOCALES retour
	
	; Initialize Framework
	invoke ALFWInit	
	invoke ALFWprintf,addr cause ;"PlayMultiChannel Test Application translated by ToutEnMasm"
	invoke ALFWInitOpenAL
	.if eax == 0
		AutreLoupe:	
		invoke ALFWprintf,addr alfailed
		invoke ALFWShutdown
		mov retour,0
		jmp FindePlayMultiChannel
	.endif
	;-------- all is ready ----------------
	;OpenAL implementations are only guaranteed to support MONO and STEREO Buffers, so we need
	;to check if this implementation supports multi-channel formats.
	;This is done by making alGetEnumValue calls to request the value of the Buffer Format Tag Enum (that will be
	;passed to an alBufferData call).   Enum Values are retrieved by string names.  The following names are defined
	;for multi-channel wave formats ...
	;"AL_FORMAT_QUAD16"	: 4 Channel,   16 bit data
	;"AL_FORMAT_51CHN16"	: 5.1 Channel, 16 bit data
	;"AL_FORMAT_61CHN16"	: 6.1 Channel, 16 bit data
	;"AL_FORMAT_71CHN16"	: 7.1 Channel, 16 bit data	
	;----------------------------------------------------------
	;For this example, we are going to play a 5.1 test file ...
	invoke alGetEnumValue,addr AL_FORMAT_51CHN16
	mov eBufferFormat,eax
	.if eBufferFormat == 0
		invoke ALFWprintf,SADR("No support for 5.1 playback!")
		echecFormat:
		invoke ALFWShutdownOpenAL
		invoke ALFWShutdown
		return 0
	.endif
	;Generate an AL Buffer
	invoke alGenBuffers,NUMBUFFERS,addr Mul_uiBuffers
	; Generate a Source to playback the Buffer
    	invoke alGenSources,1, addr uiSource 
	; Create instance of WaveLoader class
	;initilise cwave
	invoke appel_init_cwave
	;-----------------------------------------------------------------------------	
	invoke appel_OpenWaveFile,addr mediasource,addr WaveID ;ok
	.if eax < 0
		invoke ALFWprintf,addr mediafailed
		jmp echecFormat
	.endif
	invoke appel_GetWaveSize,WaveID,addr ulDataSize ;ok
	invoke appel_GetWaveFrequency,WaveID,addr ulFrequency ;ok
	;NOTE : The WaveLoader class will use alGetEnumValue to find the appropriate format tag (if supported)
	invoke appel_GetWaveALBufferFormat,WaveID,addr ulFormat ;ok
	;Queue 250ms of audio data	
	invoke appel_GetWaveFormatExHeader,WaveID,addr wfex ;ok
	mov eax,wfex.nAvgBytesPerSec
	shr eax,2
	mov	ulBufferSize,eax
	;IMPORTANT : The Buffer Size must be an exact multiple of the BlockAlignment ...
	;ulBufferSize -= (ulBufferSize % wfex.nBlockAlign);		
	movzx ecx,word ptr wfex.nBlockAlign
	mov	eax,ulBufferSize
	xor	edx, edx
	div	ecx
	mov	eax,ulBufferSize
	sub	eax, edx
	mov	ulBufferSize, eax
	.if ulFormat == 0
		invoke ALFWprintf,SADRR("Unknown Audio Buffer format")
	.else
		invoke malloc,ulBufferSize
		mov pData,eax
		.if pData == 0
			invoke ALFWprintf,SADRR("Out of memory")
		.else	
			;Set read position to start of audio data
			invoke appel_SetWaveDataOffset,WaveID, 0
			;Clear AL Error
			invoke alGetError
			;Fill all the Buffers with audio data from the wavefile
			mov iLoop,0
			Buffer_loop:
				invoke appel_ReadWaveData,WaveID, pData, ulBufferSize,addr ulBytesWritten
				.if sdword ptr eax > -1				
					mov ebx,iLoop
					lea eax,Mul_uiBuffers[ebx*4]
					invoke alBufferData,Mul_uiBuffers[ebx*4],ulFormat, pData, ulBytesWritten, ulFrequency
					invoke alSourceQueueBuffers,uiSource, 1,addr Mul_uiBuffers[ebx*4]
					invoke alGetError
					.if eax != AL_NO_ERROR
							;When a multi-channel buffer is attached to a Source (either directly using AL_BUFFER) or
							;via Source Queuing ... the call will fail if the playback device does not have enough
							;resources to play the buffer.  (On H/W devices each channel of a Buffer requires a H/W voice,
							;so to play a 5.1 Buffer on a Source requires 6 H/W Voices).
							jmp error_al
					.endif
				.endif				
				inc iLoop
			.if iLoop < NUMBUFFERS
				jmp Buffer_loop
			.endif
			.if iLoop != NUMBUFFERS
				error_al:			
				invoke ALFWprintf,SADRR("Failed to attach MultiChannel buffer to Source")
			.else
				;Start playing source
				invoke alSourcePlay,uiSource
				mov iTotalBuffersProcessed, 0
				iskeypress:
				invoke ALFWKeyPress
				.if eax == 0
					invoke Sleep,SERVICE_UPDATE_PERIOD
					;Request the number of OpenAL Buffers have been processed (played) on the Source
					mov iBuffersProcessed,0
					invoke alGetSourcei,uiSource, AL_BUFFERS_PROCESSED,addr iBuffersProcessed					
					;Keep a running count of number of buffers processed (for logging purposes only)
					;iTotalBuffersProcessed += iBuffersProcessed;
					mov	eax,iTotalBuffersProcessed
					add	eax,iBuffersProcessed
					mov	iTotalBuffersProcessed, eax					
					invoke ALFWprintf,addr BufProceed,iTotalBuffersProcessed
					;For each processed buffer, remove it from the Source Queue, read next chunk of audio
					;data from disk, fill buffer with new data, and add it to the Source Queue
					.while (iBuffersProcessed)
						;Remove the Buffer from the Queue.  (uiBuffer contains the Buffer ID for the unqueued Buffer)
						mov uiBuffer,0
						invoke alSourceUnqueueBuffers,uiSource, 1,addr uiBuffer
						;Read more audio data (if there is any)
						invoke appel_ReadWaveData,WaveID, pData,ulBufferSize,addr ulBytesWritten
						.if ulBytesWritten != 0
							;Copy audio data to Buffer
							invoke alBufferData,uiBuffer, ulFormat, pData, ulBytesWritten, ulFrequency
							;Queue Buffer on the Source
							invoke alSourceQueueBuffers,uiSource, 1,addr uiBuffer
						.endif
						dec iBuffersProcessed
					.endw
					;Check the status of the Source.  If it is not playing, then playback was either completed,
					;or the Source was starved of audio data and needs to be restarted.
					invoke alGetSourcei,uiSource, AL_SOURCE_STATE,addr iState
					.if iState != AL_PLAYING
						;If there are Buffers in the Source Queue then the Source was starved of audio
						;data, so needs to be restarted (because there is more audio data to play)
						invoke alGetSourcei,uiSource, AL_BUFFERS_QUEUED,addr iQueuedBuffers
						.if iQueuedBuffers > 0
							invoke alSourcePlay,uiSource
						.else
							;Finished playing
							jmp Finished_play
						.endif
					.endif
				.else
					jmp Finished_play
				.endif ;iskeypress
				jmp iskeypress
					Finished_play:
					;Stop the Source and clear the Queue
					invoke alSourceStop,uiSource
					invoke alSourcei,uiSource,AL_BUFFER, 0
					;Release temporary storage
					invoke free,pData
					mov pData,NULL	
													
			.endif ;iLoop == NUMBUFFERS							
		.endif ;pData != 0	
		;Close Wave Handle
		invoke appel_DeleteWaveFile,WaveID
	.endif ;ulFormat != 0
	cleanup:
    	;Clean up buffers and sources
	invoke alDeleteSources,1,addr uiSource
	invoke alDeleteBuffers,NUMBUFFERS,addr Mul_uiBuffers
	invoke ALFWShutdownOpenAL
	invoke ALFWShutdown
	invoke appel_delete
 FindePlayMultiChannel:
         mov eax,retour
         ret

PlayMultiChannel endp

;################################################################

main PROC C argc:DWORD,pargv:DWORD
	invoke CoInitializeEx, NULL, COINIT_MULTITHREADED
	;pas de ExitProcess	;la fin est dans la librairie c ainsi que le dbut
	invoke PlayMultiChannel	
	invoke CoUninitialize		
	ret
main endp

end  
	
